#ifndef Bestenliste_H
#define Bestenliste_H

#include <TextFeld.h>
#include <Array.h>
#include <Rahmen.h>

using namespace Framework;

class Spieler; // Spieler.h
class Team; // Team.h

class BLSpieler
{
private:
	int sNum;
	LRahmen *rahmen;
	TextFeld *name;
	TextFeld *punkte;
	TextFeld *kills;
	TextFeld *tode;
	TextFeld *schadenGemacht;
	TextFeld *schadenGenommen;
	TextFeld *przision;
	int ref;

public:
	// Konstruktor
	BLSpieler( int sNum, Schrift *zS );
	// Destruktor
	~BLSpieler();
	// nicht constant
	bool update( Spieler *zSpieler );
	void render( int y, Bild &zRObj );
	// constant
	int getSpielerNummer() const;
	int getPunkte() const;
	// Reference Counting
	BLSpieler *getThis();
	BLSpieler *release();
};

class BLTeam
{
private:
	int teamId;
	int spielerAnzahl;
	Schrift *schrift;
	LRahmen *rahmen;
	RCArray< BLSpieler > *spieler;
	TextFeld *name;
	TextFeld *punkte;
	int ref;

public:
	// Konstruktor
	BLTeam( int id, Schrift *s );
	// Destruktor
	~BLTeam();
	// nicht constant
	bool addSpieler( Spieler *zSpieler );
	void update( Team *zTeam );
	bool updateSpieler( Spieler *zSpieler );
	void render( int y, Bild &zRObj );
	// constant
	int getSpielerAnzahl() const;
	int getPunkte() const;
	int getHeight() const;
	// Reference Counting
	BLTeam *getThis();
	BLTeam *release();
};

class Bestenliste
{
private:
	LRahmen *rahmen;
	RCArray< BLTeam > *teams;
	TextFeld *name;
	TextFeld *punkte;
	TextFeld *kills;
	TextFeld *tode;
	TextFeld *schadenGemacht;
	TextFeld *schadenGenommen;
	TextFeld *przision;
	VScrollBar *scroll;
	Schrift *schrift;
	bool sichtbar;
	int teamAnzahl;
	int ref;

public:
	// Konstruktor
	Bestenliste( Schrift *s );
	// Destruktor
	~Bestenliste();
	// nicht constant
	void setTeamAnzahl( int anz );
	void addSpieler( Spieler *zSpieler );
	void updateSpieler( Spieler *zSpieler );
	void updateTeam( Team *zTeam );
	void doTastaturEreignis( TastaturEreignis &te );
	void doMausEreignis( MausEreignis &me );
	void render( Bild &zRObj );
	// constant
	int getTeamAnzahl() const;
	bool teamExistiert( int team ) const;
	int getTeamPunkte( int team ) const;
	// Reference Counting
	Bestenliste *getThis();
	Bestenliste *release();
};

#endif