#ifndef Chat_H
#define Chat_H

#include <KSGNetwork.h>
#include <TextFeld.h>
#include <Rahmen.h>

using namespace Framework;

class SpielChat
{
private:
	LRahmen *rahmen = 0;
	TextFeld *verlauf;
	TextFeld *nachricht;
	int ref;

public:
	// Konstruktor
	SpielChat();
	// Destruktor
	~SpielChat();
	// nicht constant
	void setSchrift( Schrift *zSchrift );
	void addNachricht( char *nachricht );
	void addNachricht( char *nachricht, int farbe );
	void doMausEreignis( MausEreignis &me );
	void doTastaturEreignis( TastaturEreignis &te, KSGClient::SpielServerClient *zKlient );
	void tick( double z );
	void render( Bild &zRObj );
	// constant
	bool istAktiv() const;
	// Reference Counting
	SpielChat *getThis();
	SpielChat *relese();
};

#endif