#ifndef SpielObjekt_H
#define SpielObjekt_H

#include <Vec2.h>
#include <Model2D.h>
#include "../Team/Team.h"
#include "../Karte/Strukturen.h"
#include <TextFeld.h>
#include <Welt2D.h>

using namespace Framework;

class SpielObjekt : public Model2DObject
{
private:
	int id;
	int style;
	double stabilitt;
	double energie;
	int maxStabilitt;
	int maxEnergie;
	int energieRadius;
	double reparatur;
	double akkuLeistung;
	double repAbk;
	double akkuAbk;
	Team *team;
	TextFeld *nText;

public:
	// Konstruktor
	SpielObjekt( ObjektStr *zStr, Schrift *zSchrift );
	// Destruktor
	~SpielObjekt();
	// nicht constant
	void setTextur( Bild *textur );
	void setTeam( Team *team );
	bool tick( const WeltInfo &info, double zeit ) override;
	void render( Mat3<float> &kamMat, Bild &zRObj, const char *kamName ) override;
	// constant
	Team *zTeam() const;
};

#endif