#pragma once

#include <Model2D.h>

using namespace Framework;

class DeadPlayer : public Object2D
{
private:
    Model2DObject *m2a;
    Model2DObject *m2b;
    double alpha;
    struct SaveData
    {
        Vertex posA;
        Vertex speedA;
        float rotA;
        float rotSA;
        Vertex posB;
        Vertex speedB;
        float rotB;
        float rotSB;
        double alpha;
    };
    SaveData alt;

public:
    DeadPlayer( Model2DData *mda, Model2DData *mdb, Vertex posa, Vertex posb, Vertex speedA, Vertex speedB, float curRotA, float curRotB, float rotA, float rotB, Textur2D *zTextur );
    ~DeadPlayer();
    void render( Mat3< float > &kamMat, Bild &zRObj, const char *kamName ) override;
    bool tick( const WeltInfo &info, double zeit ) override;
    Rect2< float > getBoundingBox() const override;
    bool isFinished() const;
    void save();
    void load();
};