#ifndef Ship_H
#define Ship_H

#include <Knopf.h>
#include <Fortschritt.h>
#include <Rahmen.h>
#include "../Spieler/Spieler.h"

using namespace Framework;

class SpielerGUI
{
private:
	LRahmen *ram;
	TextFeld *spieler;
	TextFeld *stabilitt;
	TextFeld *energie;
	FBalken *stabilittB;
	FBalken *energieB;
	TextFeld *reparatur;
	TextFeld *akkuLeistung;
	TextFeld *wendigkeit;
	TextFeld *beschleunigung;
    TextFeld *antriebEffizienz;
	TextFeld *laserIntensitt;
	TextFeld *laserEffizienz;
	TextFeld *laserTempo;
    TextFeld *energieSchild;
    TextFeld *energieSchildEffizienz;
	TextFeld *netzwerk;
    TextFeld *speed;
	Knopf *stabilittSkill;
	Knopf *energieSkill;
	Knopf *reparaturSkill;
	Knopf *akkuLeistungSkill;
	Knopf *wendigkeitSkill;
    Knopf *antriebEffizienzSkill;
	Knopf *beschleunigungSkill;
	Knopf *laserIntensittSkill;
	Knopf *laserEffizienzSkill;
	Knopf *laserTempoSkill;
    Knopf *energieSchildSkill;
    Knopf *energieSchildEffizienzSkill;
	Knopf *netzwerkSkill;
    TextFeld *skillPoints;
    Spieler *player;
	int ref;

public:
	// Konstruktor
	SpielerGUI( Schrift *zSchrift );
	// Destruktor
	~SpielerGUI();
	// nicht constant
	void update( Spieler *zSpieler );
	int doMausEreignis( MausEreignis &me );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// Reference Counting
	SpielerGUI *getThis();
	SpielerGUI *release();
};

#endif