#ifndef Team_H
#define Team_H

class Spieler; // Spieler.h
#include <Text.h>
#include <Array.h>
#include "../Karte/Strukturen.h"

using namespace Framework;

class Team
{
private:
	double maxEnergieS;
	double maxStabilittS;
	double reparaturS;
	double laserIntensittS;
	double laserEffizienzS;
	double akkuLeistungS;
	double laserTempoS;
	double beschleunigungS;
	double wendigkeitS;
    double antriebEffizienzS;
    double energieSchildS;
    double energieSchildEffizienzS;
	int ref;

public:
	// variablen
	int id;
	int farbe;
	Text name;
	RCArray< Spieler > *spieler;
	int punkte;
	int maxPunkte;
	double maxEnergie;
	double maxStabilitt;
	double reparatur;
	double laserIntensitt;
	double laserEffizienz;
	double akkuLeistung;
	double laserTempo;
	double beschleunigung;
    double antriebEffizienz;
    double energieSchild;
    double energieSchildEffizienz;
	double wendigkeit;
	// Konstruktor
	Team( int f, char *n, TeamStr *zStr );
	// Destruktor
	~Team();
	// nicht constant
	void reset();
	// constant
	double getMaxEnergieBonus() const;
	double getMaxStabilittBonus() const;
	double getReperaturBonus() const;
	double getLaserIntensittBonus() const;
	double getLaserEffizienzBonus() const;
	double getAkkuLeistungBonus() const;
	double getLaserTempoBonus() const;
	double getBeschleunigungBonus() const;
    double getAntriebEffizienzBonus() const;
    double getEnergieSchildBonus() const;
    double getEnergieSchildEffizienzBonus() const;
	double getWendigkeitBonus() const;
	// Reference Counting
	Team *getThis();
	Team *release();
};

#endif